function htmlDecode(value){
	return jQuery('<div/>').html(value).text(); 
}

function tog(v){return v?'addClass':'removeClass';}

function emefs_deploy(emefs_map_enabled,emefs_map_hasSelectedLocation) {

	if (jQuery("input#location_name").length > 0) {
		jQuery('<input>').attr({
			type: 'hidden',
			id: 'location_id',
			name: 'event[location_id]'
		}).appendTo(jQuery("input#location_name").parents('form:first'));
		jQuery("input#location_name").addClass( "clearable" );
		jQuery("input#location_name").autocomplete({
			source: function(request, response) {
				jQuery.post(emefs.ajax_url,
					{ q: request.term, action: 'emefs_locations_list'},
					function(data){
						response(jQuery.map(data, function(item) {
							return {
								id: item.id,
								label: item.name,
								name: htmlDecode(item.name),
								address1: item.address1,
								address2: item.address2,
								city: item.city,
								state: item.state,
								zip: item.zip,
								country: item.country,
								latitude: item.latitude,
								longitude: item.longitude,
							};
						}));
					}, "json");

			},
			select:function(evt, ui) {
				// when a product is selected, populate related fields in this form
				jQuery('input#location_id').val(ui.item.id).attr("readonly", true);
				jQuery('input#location_name').val(ui.item.name).attr("readonly", true);
				jQuery('input#location_address1').val(ui.item.address1).attr("readonly", true);
				jQuery('input#location_address2').val(ui.item.address2).attr("readonly", true);
				jQuery('input#location_city').val(ui.item.city).attr("readonly", true);
				jQuery('input#location_state').val(ui.item.state).attr("readonly", true);
				jQuery('input#location_zip').val(ui.item.zip).attr("readonly", true);
				jQuery('input#location_country').val(ui.item.country).attr("readonly", true);
				jQuery('input#location_latitude').val(ui.item.latitude).attr("readonly", true);
				jQuery('input#location_longitude').val(ui.item.longitude).attr("readonly", true);
				if (emefs_map_enabled) {
					emefs_displayAddress(0);
				}
				return false;
			},
			minLength: 1
		}).data( "ui-autocomplete" )._renderItem = function( ul, item ) {
			return jQuery( "<li></li>" )
				.append("<a><strong>"+htmlDecode(item.name)+'</strong><br /><small>'+htmlDecode(item.address1)+' - '+htmlDecode(item.city)+ '</small></a>')
				.appendTo( ul );
		};
		jQuery("input#location_name").change(function(){
			if (jQuery("input#location_name").val()=='') {
				jQuery('input#location_id').val('');
				jQuery('input#location_name').val('').attr("readonly", false);
				jQuery('input#location_address1').val('').attr("readonly", false);
				jQuery('input#location_address2').val('').attr("readonly", false);
				jQuery('input#location_city').val('').attr("readonly", false);
				jQuery('input#location_state').val('').attr("readonly", false);
				jQuery('input#location_zip').val('').attr("readonly", false);
				jQuery('input#location_country').val('').attr("readonly", false);
				jQuery('input#location_latitude').val('').attr("readonly", false);
				jQuery('input#location_longitude').val('').attr("readonly", false);
			}
		});
		jQuery(document).on('input', '.clearable', function(){
			jQuery(this)[tog(this.value)]('x');
		}).on('mousemove', '.x', function( e ){
			jQuery(this)[tog(this.offsetWidth-18 < e.clientX-this.getBoundingClientRect().left)]('onX');
		}).on('touchstart click', '.onX', function( ev ){
			ev.preventDefault();
			jQuery(this).removeClass('x onX').val('').change();
		});

	}

	jQuery("#localized-start-date").show();
	jQuery("#localized-end-date").show();
	jQuery("#event_start_date").hide();
	jQuery("#event_end_date").hide();

	jQuery('#localized-start-date').fdatepicker({
		todayButton: new Date(),
		autoClose: true,
		clearButton: false,
		closeButton: true,
		language: emefs.flanguage,
		firstDay: parseInt(emefs.firstDayOfWeek),
		altField: "#event_start_date",
		altFieldDateFormat: 'Y-m-d',
		dateFormat: emefs.dateformat
	});
	jQuery('#localized-start-date').fdatepicker().data('fdatepicker').selectDate(new Date());

	jQuery('#localized-end-date').fdatepicker({
		todayButton: new Date(),
		autoClose: true,
		clearButton: true,
		closeButton: true,
		language: emefs.flanguage,
		firstDay: parseInt(emefs.firstDayOfWeek),
		altField: "#event_end_date",
		altFieldDateFormat: 'Y-m-d',
		dateFormat: emefs.dateformat
	});
	jQuery('#localized-start-time').fdatepicker({
		timepicker: true,
		onlyTimepicker: true,
		clearButton: true,
		closeButton: true,
		minutesStep: parseInt(emefs.minutesStep),
		language: emefs.flanguage,
		altField: '#event_start_time',
		altFieldDateFormat: 'H:i:00',
		timeFormat: emefs.timeformat
	});
	jQuery('#localized-end-time').fdatepicker({
		timepicker: true,
		onlyTimepicker: true,
		clearButton: true,
		closeButton: true,
		minutesStep: parseInt(emefs.minutesStep),
		language: emefs.flanguage,
		altField: '#event_end_time',
		altFieldDateFormat: 'H:i:00',
		timeFormat: emefs.timeformat
	});

	if (emefs_map_enabled) {
		if (emefs_map_hasSelectedLocation) {
			emefs_displayAddress(1);
		}

		jQuery("input#location_name").change(function(){
			emefs_displayAddress(0);
		});
		jQuery("input#location_city").change(function(){
			emefs_displayAddress(1);
		});
		jQuery("input#location_state").change(function(){
			emefs_displayAddress(1);
		});
		jQuery("input#location_zip").change(function(){
			emefs_displayAddress(1);
		});
		jQuery("input#location_country").change(function(){
			emefs_displayAddress(1);
		});
		jQuery("input#location_address1").change(function(){
			emefs_displayAddress(1);
		});
		jQuery("input#location_address2").change(function(){
			emefs_displayAddress(1);
		});

		jQuery("input#location_latitude").change(function(){
			emefs_displayAddress(0);
		});
		jQuery("input#location_longitude").change(function(){
			emefs_displayAddress(0);
		});
	}
}

function emefs_displayAddress(ignore_coord) {
	eventLocation = jQuery("input#location_name").val() || ""; 
	eventAddress1 = jQuery("input#location_address1").val() || "";
	eventAddress2 = jQuery("input#location_address2").val() || "";
	eventCity = jQuery("input#location_city").val() || "";
	eventState = jQuery("input#location_state").val() || "";
	eventZip = jQuery("input#location_zip").val() || "";
	eventCountry = jQuery("input#location_country").val() || "";

	if (ignore_coord) {
		emefs_loadMapLatLong(eventLocation, eventAddress1, eventAddress2,eventCity,eventState,eventZip,eventCountry);
	} else {
		eventLat = jQuery("input#location_latitude").val();
		eventLong = jQuery("input#location_longitude").val();
		emefs_loadMapLatLong(eventLocation, eventAddress1, eventAddress2,eventCity,eventState,eventZip,eventCountry, eventLat,eventLong);
	}
}

var map;
// create the tile layer with correct attribution
var osmUrl='https://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png';
var osmAttrib='Map data © <a href="https://openstreetmap.org">OpenStreetMap</a> contributors';
var osm = new L.TileLayer(osmUrl, {attribution: osmAttrib});

function emefs_loadMap(loc_name, address1, address2, city, state, zip, country) {
	var emefs_mapCenter = L.latLng(-34.397, 150.644);
	var emefs_map = false;

	var emefs_mapOptions = {
		zoom: 12,
		center: emefs_mapCenter,
		scrollWheelZoom: true,
		doubleClickZoom: false
	}

	if (address1 !="" || address2 != "" || city!="" || state != "" || zip != "" || country != "") {
		searchKey = address1 + ", " + address2 + "," + city + ", " + zip + ", " + state + ", " + country;
	} else {
		searchKey = loc_name + ', ' + address1 + ", " + address2 + "," + city + ", " + zip + ", " + state + ", " + country;
	}

	// to avoid the leaflet error 'Map container is already initialized'
	if (map) {
		map.off();
		map.remove();
	}

	if (searchKey) {
		var geocode_url = 'https://nominatim.openstreetmap.org/search?format=json&limit=1';
		jQuery.getJSON( geocode_url, { 'q': searchKey}, function(data) {
			if (data.length===0) {
				jQuery("#event-map").hide();
			} else {
				// first we show the map, so leaflet can check the size
				//jQuery('#event-map').show();
				jQuery("#event-map").show();
				map = L.map('event-map', emefs_mapOptions);
				map.addLayer(osm);
				map.panTo([data[0].lat, data[0].lon]);
				var marker = L.marker(data[0]).addTo(map);
				var pop_content='<div class=\"eme-location-balloon\"><strong>' + loc_name +'</strong><p>' + address1 + ' ' + address2 + '<br />' + city + ' ' + state + ' ' + zip + ' ' + country + '</p></div>';
				marker.bindPopup(pop_content).openPopup();
				jQuery('input#location_latitude').val(data[0].lat);
				jQuery('input#location_longitude').val(data[0].lon);
			}
		});
	}
}

function emefs_loadMapLatLong(loc_name, address1, address2, city, state, zip, country, lat, lon) {
	if (lat === undefined) {
		lat = 0;
	}
	if (lon === undefined) {
		lon = 0;
	}

	if (lat != 0 && lon != 0) {
		var emefs_mapCenter = L.latLng(lat, lon);
		var emefs_map = false;

		var emefs_mapOptions = {
			zoom: 12,
			center: emefs_mapCenter,
			scrollWheelZoom: true,
			doubleClickZoom: false
		}
		// to avoid the leaflet error 'Map container is already initialized'
		if (map) {
			map.off();
			map.remove();
		}
		// first we show the map, so leaflet can check the size
		//jQuery("#event-map").slideDown('fast');
		jQuery("#event-map").show();
		map = L.map('event-map', emefs_mapOptions);
		map.addLayer(osm);
		var marker = L.marker(emefs_mapCenter).addTo(map);
		var pop_content='<div class=\"eme-location-balloon\"><strong>' + loc_name +'</strong><p>' + address1 + ' ' + address2 + '<br />' + city + ' ' + state + ' ' + zip + ' ' + country + '</p></div>';
		marker.bindPopup(pop_content).openPopup();
	} else {
		emefs_loadMap(loc_name, address1, address2, city, state, zip, country);
	}
}

